function [ dist_hl, dist_err ] = approx_da_distance(Xs, Xt, learner, varargin)

switch numel(varargin)
    case 0
        params = struct();
        ws = ones(size(Xs,1),1);
        wt = ones(size(Xt,1),1);
    case 1
        params = varargin{1};
        ws = ones(size(Xs,1),1);
        wt = ones(size(Xt,1),1);
    case 2
        params = varargin{1};
        ws = varargin{2};
        wt = ones(size(Xt,1),1);
    otherwise
        params = varargin{1};
        ws = varargin{2};
        wt = varargin{3};
end
if isempty(ws)
    ws = ones(size(Xs,1),1);
end
if isempty(wt)
    wt = ones(size(Xt,1),1);
end

k = 10;
X = [Xs;Xt];
y = [ones(size(Xs,1),1); -ones(size(Xt,1),1)];
w = [ws; wt];
f = data_kfold(y, k, true);
err = zeros(1,k);
hloss = zeros(1,k);
for fi=1:k
    h  = learner(X(f~=fi,:), y(f~=fi), w(f~=fi), params);
    [ yh, ydv ] = h(X(f==fi));
    err(fi) = sum(yh~=y(f==fi)) / sum(f==fi);
    hloss(fi) = sum(min(1, max(0, 1 - y(f==fi).*ydv))) / sum(f==fi);
end

dist_err = 1 - mean(err);
dist_hl = 1 - mean(hloss);

end
