function [wt, ws, dom_s] = compute_blitzer_tl_weights(dom, alpha_t, alpha_s)

assert(any(dom==0))
assert((alpha_t + sum(alpha_s)-1) < 1E-12)

if size(alpha_s,2) > size(alpha_s,1)
    alpha_s = alpha_s';
end

cts = tabulate(dom);
cts = cts(cts(:,2)>0,:);
dom_s = cts(2:end,1);
assert(length(dom_s) == length(alpha_s))

beta_t = cts(1,3)/100;
beta_s = cts(2:end,3)/100;
assert(length(beta_s) == length(alpha_s))

wt = alpha_t / beta_t;
ws = alpha_s ./ beta_s;

end
