function part = data_split(labels, frac)

assert(abs(sum(frac) - 1.0) < eps) % frac should sum to 1!

n = length(labels);

grp = [];
for fi=1:(length(frac)-1)
    grp = [ grp; repmat(fi, max(1, floor(frac(fi) * n)), 1) ];
end
grp = [ grp; repmat(length(frac), n - length(grp), 1) ];

inds = randperm(n);

[~, idx] = sort(inds);
part = grp(idx);

end
