function [ h, hp ] = knn(X, y, w, params)

if isfield(params, 'k')
    k = params.k;
else
    k = 1;
end

h = model_wrapper(X, y, w, k);
hp = [];

end


function h = model_wrapper(X, y, ~, k)

h = @predict;
    
    function [ yhat, ydv ] = predict(Xnew)
        yhat = zeros(size(Xnew,1),1);
        ydv = zeros(size(Xnew,1),1);
        for i=1:size(Xnew,1)
            [d,idx] = min(sum(bsxfun(@minus, X, Xnew(i,:)).^2,2),[],1);
            yhat(i) = y(idx);
            ydv(i) = d;
        end
    end

end
